/* File generated by: simse.codegenerator.guigenerator.AtAGlanceFramesGenerator */
package simse.gui;

import simse.state.*;

import java.awt.event.*;
import java.awt.*;
import java.awt.Dimension;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.table.*;
import javax.swing.border.*;
import java.util.*;
import java.text.*;
import java.awt.Color;

public class EmployeesAtAGlanceFrame extends JFrame implements MouseListener, ActionListener
{

private State state;

private JPopupMenu popup;
private PopupListener popupListener;
private JTable softwaredeveloperTable;
private SoftwareDeveloperTableModel softwaredeveloperModel;
private JPanel softwaredeveloperTitlePane;
private JTable managerTable;
private ManagerTableModel managerModel;
private JPanel managerTitlePane;
private JTable customerrepTable;
private CustomerRepTableModel customerrepModel;
private JPanel customerrepTitlePane;
private JPanel mainPane;

private int realColumnIndex; // index of selected column
private JTable selectedTable; // selected table

public EmployeesAtAGlanceFrame(State s,SimSEGUI gui)
{
state = s;
// Set window title:
setTitle("Employees At-A-Glance");

// Create tables:
int numCols;

softwaredeveloperModel = new SoftwareDeveloperTableModel(s);
softwaredeveloperTable = new JTable(softwaredeveloperModel);
softwaredeveloperTable.setColumnSelectionAllowed(false);
softwaredeveloperTable.setRowSelectionAllowed(false);
softwaredeveloperTable.addMouseListener(this);
softwaredeveloperTable.getTableHeader().setReorderingAllowed(false);
// make it so that the user can make each column disappear if they want:
numCols = softwaredeveloperTable.getColumnCount();
for(int i=0; i<numCols; i++)
{
softwaredeveloperTable.getColumnModel().getColumn(i).setMinWidth(0);
}
managerModel = new ManagerTableModel(s);
managerTable = new JTable(managerModel);
managerTable.setColumnSelectionAllowed(false);
managerTable.setRowSelectionAllowed(false);
managerTable.addMouseListener(this);
managerTable.getTableHeader().setReorderingAllowed(false);
// make it so that the user can make each column disappear if they want:
numCols = managerTable.getColumnCount();
for(int i=0; i<numCols; i++)
{
managerTable.getColumnModel().getColumn(i).setMinWidth(0);
}
customerrepModel = new CustomerRepTableModel(s);
customerrepTable = new JTable(customerrepModel);
customerrepTable.setColumnSelectionAllowed(false);
customerrepTable.setRowSelectionAllowed(false);
customerrepTable.addMouseListener(this);
customerrepTable.getTableHeader().setReorderingAllowed(false);
// make it so that the user can make each column disappear if they want:
numCols = customerrepTable.getColumnCount();
for(int i=0; i<numCols; i++)
{
customerrepTable.getColumnModel().getColumn(i).setMinWidth(0);
}

// right click menu:
popup = new JPopupMenu();
popupListener = new PopupListener(popup,gui);

// Create panes:
JScrollPane softwaredeveloperPane = new JScrollPane(softwaredeveloperTable);
JScrollPane managerPane = new JScrollPane(managerTable);
JScrollPane customerrepPane = new JScrollPane(customerrepTable);

// Table headers:
softwaredeveloperTitlePane = new JPanel();
softwaredeveloperTitlePane.add(new JLabel("SoftwareDevelopers:"));
managerTitlePane = new JPanel();
managerTitlePane.add(new JLabel("Managers:"));
customerrepTitlePane = new JPanel();
customerrepTitlePane.add(new JLabel("CustomerReps:"));

// Create main pane:
mainPane = new JPanel();
mainPane.setLayout(new BoxLayout(mainPane, BoxLayout.Y_AXIS));

// Add panes to main pane:
mainPane.add(softwaredeveloperTitlePane);
mainPane.add(softwaredeveloperPane);
mainPane.add(managerTitlePane);
mainPane.add(managerPane);
mainPane.add(customerrepTitlePane);
mainPane.add(customerrepPane);

// Set main window frame properties:
setBackground(Color.white);
setContentPane(mainPane);
setVisible(false);
pack();
validate();

resetHeight();
}


public void mousePressed(MouseEvent me){}
public void mouseClicked(MouseEvent me){}
public void mouseEntered(MouseEvent me){}
public void mouseExited(MouseEvent me){}

public void mouseReleased(MouseEvent me)
{
Point p = me.getPoint();

if(me.isPopupTrigger())
{
if(me.getComponent().equals(softwaredeveloperTable)) // correct table
{
createPopupMenu(softwaredeveloperTable, p);
}
else if(me.getComponent().equals(managerTable)) // correct table
{
createPopupMenu(managerTable, p);
}
else if(me.getComponent().equals(customerrepTable)) // correct table
{
createPopupMenu(customerrepTable, p);
}
}
}


public void actionPerformed(ActionEvent e)	// dealing with actions generated by popup menus
{
Object source = e.getSource();
if(source instanceof JMenuItem)
{
String itemText = ((JMenuItem)source).getText();
if(itemText.equals("Hide"))
{
if(selectedTable != null)
{
selectedTable.getColumnModel().getColumn(realColumnIndex).setMaxWidth(0);
}
}
else // an item on the "Unhide" menu
{
if(selectedTable != null)
{
TableModel model = selectedTable.getModel();
TableColumn column = null;
if(model instanceof SoftwareDeveloperTableModel)
{
column = selectedTable.getColumnModel().getColumn(((SoftwareDeveloperTableModel)selectedTable.getModel()).getColumnIndex(itemText));
}
else if(model instanceof ManagerTableModel)
{
column = selectedTable.getColumnModel().getColumn(((ManagerTableModel)selectedTable.getModel()).getColumnIndex(itemText));
}
else if(model instanceof CustomerRepTableModel)
{
column = selectedTable.getColumnModel().getColumn(((CustomerRepTableModel)selectedTable.getModel()).getColumnIndex(itemText));
}
if(column != null)
{
column.setMinWidth(0);
column.setMaxWidth(2147483647);
column.setPreferredWidth(selectedTable.getWidth() / (selectedTable.getColumnCount() - getAllHiddenColumnIndices(selectedTable).size() + 1));
}
}
}
}
}


public void createPopupMenu(JTable table, Point p)
{
popup.removeAll();

int colIndex = table.columnAtPoint(p);
realColumnIndex = table.convertColumnIndexToModel(colIndex);

Vector<Integer> hiddenCols = getAllHiddenColumnIndices(table);

if((realColumnIndex >= 0) || (hiddenCols.size() > 0)) // user clicked on a column and/or there is at least one hidden column
{
if(realColumnIndex >= 0)
{
JMenuItem hideItem = new JMenuItem("Hide");
hideItem.addActionListener(this);
popup.add(hideItem);
}

if(hiddenCols.size() > 0) // there is at least one hidden column
{
JMenu unhideMenu = new JMenu("Unhide");
for(int i=0; i<hiddenCols.size(); i++)
{
int index = hiddenCols.elementAt(i).intValue();
JMenuItem tempItem = new JMenuItem(table.getColumnName(index));
tempItem.addActionListener(this);
unhideMenu.add(tempItem);
}
if(popup.getComponents().length > 0) // already has the hide menu item
{
popup.addSeparator();
}
popup.add(unhideMenu);
}

addMouseListener(popupListener);
popup.show(table, (int)p.getX(), (int)p.getY());
selectedTable = table;
repaint();
}
}


public void update()
{
DefaultTableCellRenderer rightAlignRenderer = new DefaultTableCellRenderer();
rightAlignRenderer.setHorizontalAlignment(JLabel.RIGHT);
softwaredeveloperModel.update();
if (!state.getClock().isStopped()) { // game not over
}
else { // game over
}
softwaredeveloperTable.update(softwaredeveloperTable.getGraphics());
managerModel.update();
if (!state.getClock().isStopped()) { // game not over
}
else { // game over
}
managerTable.update(managerTable.getGraphics());
customerrepModel.update();
if (!state.getClock().isStopped()) { // game not over
}
else { // game over
}
customerrepTable.update(customerrepTable.getGraphics());
resetHeight();
}
private void resetHeight()
{
// Set appropriate height:
double height = 0;
height += ((softwaredeveloperTable.getRowHeight() + (softwaredeveloperTable.getRowMargin() * 2)) * (softwaredeveloperTable.getRowCount() + 1));
height += softwaredeveloperTitlePane.getSize().getHeight();
height += ((managerTable.getRowHeight() + (managerTable.getRowMargin() * 2)) * (managerTable.getRowCount() + 1));
height += managerTitlePane.getSize().getHeight();
height += ((customerrepTable.getRowHeight() + (customerrepTable.getRowMargin() * 2)) * (customerrepTable.getRowCount() + 1));
height += customerrepTitlePane.getSize().getHeight();

mainPane.setPreferredSize(new Dimension((int)(mainPane.getSize().getWidth()), (int)height));
pack();
validate();
repaint();
}



private Vector<Integer> getAllHiddenColumnIndices(JTable table)
{
Vector<Integer> hiddenCols = new Vector<Integer>();
int numCols = table.getColumnModel().getColumnCount();
for(int i=0; i<numCols; i++)
{
TableColumn col = table.getColumnModel().getColumn(i);
if(col.getWidth() == 0) // hidden
{
hiddenCols.add(new Integer(i));
}
}
return hiddenCols;
}
}