/* File generated by: simse.codegenerator.logicgenerator.dialoggenerator.EmployeeParticipantSelectionDialogGenerator */
package simse.logic.dialogs;
import simse.gui.ImageLoader;
import simse.gui.TabPanel;
import simse.state.*;
import simse.adts.objects.*;
import simse.adts.actions.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.border.*;
import javax.swing.event.*;
public class EmployeeParticipantSelectionDialog extends JDialog implements ActionListener
{
private String partName;
private Vector<SSObject> participants;
private simse.adts.actions.Action action;
private State state;
private Employee selectedEmp;
private int minNumParts;
private int maxNumParts;
private Vector<JCheckBox> checkBoxes;
private JButton checkAllButton;
private JButton clearAllButton;
private JButton okButton;
private JButton cancelButton;
private boolean actionCancelled;
public EmployeeParticipantSelectionDialog(JFrame owner, String pName, Vector<SSObject> parts, simse.adts.actions.Action act, State s, Employee emp)
{
super(owner, true);
partName = pName;
participants = parts;
action = act;
state = s;
selectedEmp = emp;
actionCancelled = false;
setMinAndMax();
if(((selectedEmp != null) && (maxNumParts > 0) && (participants.size() > 0)) || ((selectedEmp == null) && (participants.size() > minNumParts)))
{
checkBoxes = new Vector<JCheckBox>();
setTitle("Participant Selection");
Box mainPane = Box.createVerticalBox();
JPanel topPane = new JPanel();
String title = "Choose ";
if(selectedEmp != null) // selected emp already added in this participant role
{
title = title.concat("other ");
}
title = title.concat(partName + " participant(s) (");
if(minNumParts == maxNumParts)
{
title = title.concat("exactly " + minNumParts);
}
else
{
title = title.concat("at least " + minNumParts);
if(maxNumParts < 999999) // not boundless
{
title = title.concat(", at most " + maxNumParts);
}
}
title = title.concat("):");
topPane.add(new JLabel(title));
JPanel middlePane = new JPanel(new GridLayout(0, 1));
for(int i=0; i<participants.size(); i++)
{
SSObject tempObj = participants.elementAt(i);
String label = new String();
if(tempObj instanceof SoftwareDeveloper)
{
label = ("SoftwareDeveloper (" + ((SoftwareDeveloper)tempObj).getName() + ")");
}
else if(tempObj instanceof Manager)
{
label = ("Manager (" + ((Manager)tempObj).getName() + ")");
}
else if(tempObj instanceof CustomerRepresentative)
{
label = ("CustomerRepresentative (" + ((CustomerRepresentative)tempObj).getName() + ")");
}
else if(tempObj instanceof UserStories)
{
label = ("UserStories (" + ((UserStories)tempObj).getName() + ")");
}
else if(tempObj instanceof CustomerRep)
{
label = ("CustomerRep (" + ((CustomerRep)tempObj).getName() + ")");
}
else if(tempObj instanceof ReleasePlan)
{
label = ("ReleasePlan (" + ((ReleasePlan)tempObj).getName() + ")");
}
else if(tempObj instanceof TheProject)
{
label = ("TheProject (" + ((TheProject)tempObj).getName() + ")");
}
else if(tempObj instanceof CurrentIterationPlan)
{
label = ("CurrentIterationPlan (" + ((CurrentIterationPlan)tempObj).getName() + ")");
}
else if(tempObj instanceof AcceptanceTests)
{
label = ("AcceptanceTests (" + ((AcceptanceTests)tempObj).getDescription() + ")");
}
else if(tempObj instanceof CRCCards)
{
label = ("CRCCards (" + ((CRCCards)tempObj).getDescription() + ")");
}
else if(tempObj instanceof Design)
{
label = ("Design (" + ((Design)tempObj).getDescription() + ")");
}
else if(tempObj instanceof UnitTestingFramework)
{
label = ("UnitTestingFramework (" + ((UnitTestingFramework)tempObj).getDescription() + ")");
}
else if(tempObj instanceof UnitTests)
{
label = ("UnitTests (" + ((UnitTests)tempObj).getDescription() + ")");
}
else if(tempObj instanceof Code)
{
label = ("Code (" + ((Code)tempObj).getDescription() + ")");
}
else if(tempObj instanceof CodingStandard)
{
label = ("CodingStandard (" + ((CodingStandard)tempObj).getDescription() + ")");
}
else if(tempObj instanceof RefactoringTool)
{
label = ("RefactoringTool (" + ((RefactoringTool)tempObj).getDescription() + ")");
}
JPanel tempPane = new JPanel(new BorderLayout());
JCheckBox tempCheckBox = new JCheckBox(label);
tempPane.add(tempCheckBox, BorderLayout.WEST);
checkBoxes.add(tempCheckBox);
ImageIcon icon =  new ImageIcon(ImageLoader.getImageFromURL(TabPanel.getImage(tempObj)).getScaledInstance(30, 30, Image.SCALE_AREA_AVERAGING));
tempPane.add(new JLabel(icon), BorderLayout.EAST);
middlePane.add(tempPane);
}
JPanel checkPane = new JPanel();
checkAllButton = new JButton("Check All");
checkAllButton.addActionListener(this);
checkPane.add(checkAllButton);
clearAllButton = new JButton("Clear All");
clearAllButton.addActionListener(this);
checkPane.add(clearAllButton);
JPanel bottomPane = new JPanel();
okButton = new JButton("OK");
okButton.addActionListener(this);
bottomPane.add(okButton);
cancelButton = new JButton("Cancel");
cancelButton.addActionListener(this);
bottomPane.add(cancelButton);
mainPane.add(topPane);
mainPane.add(middlePane);
JSeparator separator1 = new JSeparator();
separator1.setMaximumSize(new Dimension(900, 1));
mainPane.add(separator1);
mainPane.add(checkPane);
JSeparator separator2 = new JSeparator();
separator2.setMaximumSize(new Dimension(900, 1));
mainPane.add(separator2);
mainPane.add(bottomPane);
addWindowListener(new ExitListener());
setContentPane(mainPane);
validate();
pack();
repaint();
toFront();
Point ownerLoc = owner.getLocationOnScreen();
Point thisLoc = new Point();
thisLoc.setLocation((ownerLoc.getX() + (owner.getWidth() / 2) - (this.getWidth() / 2)), (ownerLoc.getY() + (owner.getHeight() / 2) - (this.getHeight() / 2)));
setLocation(thisLoc);
setVisible(true);
}
else if ((selectedEmp == null) && (participants.size() == minNumParts)) {
for (int i = 0; i < participants.size(); i++) {
Employee tempEmp = (Employee) participants.elementAt(i);
if(action instanceof CreateUserStoriesAction)
{
if(partName.equals("Developer"))
{
((CreateUserStoriesAction)action).addDeveloper(tempEmp);
}
else if(partName.equals("CustomerRep"))
{
((CreateUserStoriesAction)action).addCustomerRep(tempEmp);
}
}
else if(action instanceof ReleasePlanningMeetingAction)
{
if(partName.equals("Developer"))
{
((ReleasePlanningMeetingAction)action).addDeveloper(tempEmp);
}
else if(partName.equals("Manager"))
{
((ReleasePlanningMeetingAction)action).addManager(tempEmp);
}
else if(partName.equals("CustomerRep"))
{
((ReleasePlanningMeetingAction)action).addCustomerRep(tempEmp);
}
}
else if(action instanceof StartIterationAction)
{
if(partName.equals("Emp"))
{
((StartIterationAction)action).addEmp(tempEmp);
}
else if(partName.equals("CustomerRep"))
{
((StartIterationAction)action).addCustomerRep(tempEmp);
}
}
else if(action instanceof IterationPlanningMeetingAction)
{
if(partName.equals("Developer"))
{
((IterationPlanningMeetingAction)action).addDeveloper(tempEmp);
}
else if(partName.equals("CustomerRep"))
{
((IterationPlanningMeetingAction)action).addCustomerRep(tempEmp);
}
}
else if(action instanceof CreateAcceptanceTestsAction)
{
if(partName.equals("Developer"))
{
((CreateAcceptanceTestsAction)action).addDeveloper(tempEmp);
}
else if(partName.equals("CustRep"))
{
((CreateAcceptanceTestsAction)action).addCustRep(tempEmp);
}
}
else if(action instanceof DesignAction)
{
if(partName.equals("Developer"))
{
((DesignAction)action).addDeveloper(tempEmp);
}
}
else if(action instanceof CreateUnitTestsAction)
{
if(partName.equals("Developer"))
{
((CreateUnitTestsAction)action).addDeveloper(tempEmp);
}
}
else if(action instanceof LearnCodingStandardAction)
{
if(partName.equals("Developer"))
{
((LearnCodingStandardAction)action).addDeveloper(tempEmp);
}
}
else if(action instanceof ProgramAction)
{
if(partName.equals("Developer"))
{
((ProgramAction)action).addDeveloper(tempEmp);
}
}
else if(action instanceof PairProgramRobertJoyceAction)
{
if(partName.equals("Robert"))
{
((PairProgramRobertJoyceAction)action).addRobert(tempEmp);
}
else if(partName.equals("Joyce"))
{
((PairProgramRobertJoyceAction)action).addJoyce(tempEmp);
}
}
else if(action instanceof PairProgramTimothyRedaAction)
{
if(partName.equals("Timothy"))
{
((PairProgramTimothyRedaAction)action).addTimothy(tempEmp);
}
else if(partName.equals("Reda"))
{
((PairProgramTimothyRedaAction)action).addReda(tempEmp);
}
}
else if(action instanceof PairProgramPegSigfreidoAction)
{
if(partName.equals("Peg"))
{
((PairProgramPegSigfreidoAction)action).addPeg(tempEmp);
}
else if(partName.equals("Sigfreido"))
{
((PairProgramPegSigfreidoAction)action).addSigfreido(tempEmp);
}
}
else if(action instanceof UnitTestingAndFixingAction)
{
if(partName.equals("Emp"))
{
((UnitTestingAndFixingAction)action).addEmp(tempEmp);
}
}
else if(action instanceof RefactorAction)
{
if(partName.equals("Emp"))
{
((RefactorAction)action).addEmp(tempEmp);
}
}
else if(action instanceof IntegrateRobertJoyceAction)
{
if(partName.equals("Robert"))
{
((IntegrateRobertJoyceAction)action).addRobert(tempEmp);
}
else if(partName.equals("Joyce"))
{
((IntegrateRobertJoyceAction)action).addJoyce(tempEmp);
}
}
else if(action instanceof IntegrateTimothyRedaAction)
{
if(partName.equals("Timothy"))
{
((IntegrateTimothyRedaAction)action).addTimothy(tempEmp);
}
else if(partName.equals("Reda"))
{
((IntegrateTimothyRedaAction)action).addReda(tempEmp);
}
}
else if(action instanceof IntegratePegSigfreidoAction)
{
if(partName.equals("Peg"))
{
((IntegratePegSigfreidoAction)action).addPeg(tempEmp);
}
else if(partName.equals("Sigfreido"))
{
((IntegratePegSigfreidoAction)action).addSigfreido(tempEmp);
}
}
else if(action instanceof IntegrateAction)
{
if(partName.equals("Emp"))
{
((IntegrateAction)action).addEmp(tempEmp);
}
}
else if(action instanceof AcceptanceTestingAction)
{
if(partName.equals("Emp"))
{
((AcceptanceTestingAction)action).addEmp(tempEmp);
}
}
else if(action instanceof ReleaseCodeAndEndIterationAction)
{
if(partName.equals("Emp"))
{
((ReleaseCodeAndEndIterationAction)action).addEmp(tempEmp);
}
}
else if(action instanceof DeliverFinalProductToCustomerAction)
{
if(partName.equals("Emp"))
{
((DeliverFinalProductToCustomerAction)action).addEmp(tempEmp);
}
}
}
}if(selectedEmp != null)
{
if(action instanceof CreateUserStoriesAction)
{
if(partName.equals("Developer"))
{
((CreateUserStoriesAction)action).addDeveloper(selectedEmp);
}
else if(partName.equals("CustomerRep"))
{
((CreateUserStoriesAction)action).addCustomerRep(selectedEmp);
}
}
else if(action instanceof ReleasePlanningMeetingAction)
{
if(partName.equals("Developer"))
{
((ReleasePlanningMeetingAction)action).addDeveloper(selectedEmp);
}
else if(partName.equals("Manager"))
{
((ReleasePlanningMeetingAction)action).addManager(selectedEmp);
}
else if(partName.equals("CustomerRep"))
{
((ReleasePlanningMeetingAction)action).addCustomerRep(selectedEmp);
}
}
else if(action instanceof StartIterationAction)
{
if(partName.equals("Emp"))
{
((StartIterationAction)action).addEmp(selectedEmp);
}
else if(partName.equals("CustomerRep"))
{
((StartIterationAction)action).addCustomerRep(selectedEmp);
}
}
else if(action instanceof IterationPlanningMeetingAction)
{
if(partName.equals("Developer"))
{
((IterationPlanningMeetingAction)action).addDeveloper(selectedEmp);
}
else if(partName.equals("CustomerRep"))
{
((IterationPlanningMeetingAction)action).addCustomerRep(selectedEmp);
}
}
else if(action instanceof CreateAcceptanceTestsAction)
{
if(partName.equals("Developer"))
{
((CreateAcceptanceTestsAction)action).addDeveloper(selectedEmp);
}
else if(partName.equals("CustRep"))
{
((CreateAcceptanceTestsAction)action).addCustRep(selectedEmp);
}
}
else if(action instanceof DesignAction)
{
if(partName.equals("Developer"))
{
((DesignAction)action).addDeveloper(selectedEmp);
}
}
else if(action instanceof CreateUnitTestsAction)
{
if(partName.equals("Developer"))
{
((CreateUnitTestsAction)action).addDeveloper(selectedEmp);
}
}
else if(action instanceof LearnCodingStandardAction)
{
if(partName.equals("Developer"))
{
((LearnCodingStandardAction)action).addDeveloper(selectedEmp);
}
}
else if(action instanceof ProgramAction)
{
if(partName.equals("Developer"))
{
((ProgramAction)action).addDeveloper(selectedEmp);
}
}
else if(action instanceof PairProgramRobertJoyceAction)
{
if(partName.equals("Robert"))
{
((PairProgramRobertJoyceAction)action).addRobert(selectedEmp);
}
else if(partName.equals("Joyce"))
{
((PairProgramRobertJoyceAction)action).addJoyce(selectedEmp);
}
}
else if(action instanceof PairProgramTimothyRedaAction)
{
if(partName.equals("Timothy"))
{
((PairProgramTimothyRedaAction)action).addTimothy(selectedEmp);
}
else if(partName.equals("Reda"))
{
((PairProgramTimothyRedaAction)action).addReda(selectedEmp);
}
}
else if(action instanceof PairProgramPegSigfreidoAction)
{
if(partName.equals("Peg"))
{
((PairProgramPegSigfreidoAction)action).addPeg(selectedEmp);
}
else if(partName.equals("Sigfreido"))
{
((PairProgramPegSigfreidoAction)action).addSigfreido(selectedEmp);
}
}
else if(action instanceof UnitTestingAndFixingAction)
{
if(partName.equals("Emp"))
{
((UnitTestingAndFixingAction)action).addEmp(selectedEmp);
}
}
else if(action instanceof RefactorAction)
{
if(partName.equals("Emp"))
{
((RefactorAction)action).addEmp(selectedEmp);
}
}
else if(action instanceof IntegrateRobertJoyceAction)
{
if(partName.equals("Robert"))
{
((IntegrateRobertJoyceAction)action).addRobert(selectedEmp);
}
else if(partName.equals("Joyce"))
{
((IntegrateRobertJoyceAction)action).addJoyce(selectedEmp);
}
}
else if(action instanceof IntegrateTimothyRedaAction)
{
if(partName.equals("Timothy"))
{
((IntegrateTimothyRedaAction)action).addTimothy(selectedEmp);
}
else if(partName.equals("Reda"))
{
((IntegrateTimothyRedaAction)action).addReda(selectedEmp);
}
}
else if(action instanceof IntegratePegSigfreidoAction)
{
if(partName.equals("Peg"))
{
((IntegratePegSigfreidoAction)action).addPeg(selectedEmp);
}
else if(partName.equals("Sigfreido"))
{
((IntegratePegSigfreidoAction)action).addSigfreido(selectedEmp);
}
}
else if(action instanceof IntegrateAction)
{
if(partName.equals("Emp"))
{
((IntegrateAction)action).addEmp(selectedEmp);
}
}
else if(action instanceof AcceptanceTestingAction)
{
if(partName.equals("Emp"))
{
((AcceptanceTestingAction)action).addEmp(selectedEmp);
}
}
else if(action instanceof ReleaseCodeAndEndIterationAction)
{
if(partName.equals("Emp"))
{
((ReleaseCodeAndEndIterationAction)action).addEmp(selectedEmp);
}
}
else if(action instanceof DeliverFinalProductToCustomerAction)
{
if(partName.equals("Emp"))
{
((DeliverFinalProductToCustomerAction)action).addEmp(selectedEmp);
}
}
}
}

public void actionPerformed(ActionEvent evt)
{
Object source = evt.getSource();
if(source == cancelButton)
{
actionCancelled = true;
setVisible(false);
dispose();
}
else if(source == okButton)
{
Vector<JCheckBox> checkedBoxes = new Vector<JCheckBox>();
for(int i=0; i<checkBoxes.size(); i++)
{
JCheckBox tempCBox = checkBoxes.elementAt(i);
if(tempCBox.isSelected())
{
checkedBoxes.add(tempCBox);
}
}
if(checkedBoxes.size() < minNumParts)
{
JOptionPane.showMessageDialog(null, ("You must choose at least " + minNumParts + " participants"), "Invalid Input", JOptionPane.ERROR_MESSAGE);
}
else if(checkedBoxes.size() > maxNumParts)
{
JOptionPane.showMessageDialog(null, ("You may only choose at most " + maxNumParts + " participants"), "Invalid Input", JOptionPane.ERROR_MESSAGE);
}
else
{
for(int i=0; i<checkedBoxes.size(); i++)
{
JCheckBox checkedBox = checkedBoxes.elementAt(i);
String cBoxText = checkedBox.getText();
String objTypeName = cBoxText.substring(0, (cBoxText.indexOf('(') - 1));
String keyValStr = cBoxText.substring((cBoxText.indexOf('(') + 1), cBoxText.lastIndexOf(')'));

addParticipant(objTypeName, keyValStr);
}
setVisible(false);
dispose();
}
}
else if (source == checkAllButton) {
for (int i = 0; i < checkBoxes.size(); i++) {
checkBoxes.elementAt(i).setSelected(true);
}
}
else if (source == clearAllButton) {
for (int i = 0; i < checkBoxes.size(); i++) {
checkBoxes.elementAt(i).setSelected(false);
}
}
}

private void addParticipant(String objTypeName, String keyValStr)
{
if(objTypeName.equals("SoftwareDeveloper"))
{
SoftwareDeveloper a = state.getEmployeeStateRepository().getSoftwareDeveloperStateRepository().get(keyValStr);
if(a != null)
{
if(action instanceof CreateUserStoriesAction)
{
if(partName.equals("Developer"))
{
((CreateUserStoriesAction)action).addDeveloper(a);
}
}
else if(action instanceof ReleasePlanningMeetingAction)
{
if(partName.equals("Developer"))
{
((ReleasePlanningMeetingAction)action).addDeveloper(a);
}
}
else if(action instanceof StartIterationAction)
{
if(partName.equals("Emp"))
{
((StartIterationAction)action).addEmp(a);
}
}
else if(action instanceof IterationPlanningMeetingAction)
{
if(partName.equals("Developer"))
{
((IterationPlanningMeetingAction)action).addDeveloper(a);
}
}
else if(action instanceof CreateAcceptanceTestsAction)
{
if(partName.equals("Developer"))
{
((CreateAcceptanceTestsAction)action).addDeveloper(a);
}
}
else if(action instanceof DesignAction)
{
if(partName.equals("Developer"))
{
((DesignAction)action).addDeveloper(a);
}
}
else if(action instanceof CreateUnitTestsAction)
{
if(partName.equals("Developer"))
{
((CreateUnitTestsAction)action).addDeveloper(a);
}
}
else if(action instanceof LearnCodingStandardAction)
{
if(partName.equals("Developer"))
{
((LearnCodingStandardAction)action).addDeveloper(a);
}
}
else if(action instanceof ProgramAction)
{
if(partName.equals("Developer"))
{
((ProgramAction)action).addDeveloper(a);
}
}
else if(action instanceof PairProgramRobertJoyceAction)
{
if(partName.equals("Robert"))
{
((PairProgramRobertJoyceAction)action).addRobert(a);
}
else if(partName.equals("Joyce"))
{
((PairProgramRobertJoyceAction)action).addJoyce(a);
}
}
else if(action instanceof PairProgramTimothyRedaAction)
{
if(partName.equals("Timothy"))
{
((PairProgramTimothyRedaAction)action).addTimothy(a);
}
else if(partName.equals("Reda"))
{
((PairProgramTimothyRedaAction)action).addReda(a);
}
}
else if(action instanceof PairProgramPegSigfreidoAction)
{
if(partName.equals("Peg"))
{
((PairProgramPegSigfreidoAction)action).addPeg(a);
}
else if(partName.equals("Sigfreido"))
{
((PairProgramPegSigfreidoAction)action).addSigfreido(a);
}
}
else if(action instanceof UnitTestingAndFixingAction)
{
if(partName.equals("Emp"))
{
((UnitTestingAndFixingAction)action).addEmp(a);
}
}
else if(action instanceof RefactorAction)
{
if(partName.equals("Emp"))
{
((RefactorAction)action).addEmp(a);
}
}
else if(action instanceof IntegrateRobertJoyceAction)
{
if(partName.equals("Robert"))
{
((IntegrateRobertJoyceAction)action).addRobert(a);
}
else if(partName.equals("Joyce"))
{
((IntegrateRobertJoyceAction)action).addJoyce(a);
}
}
else if(action instanceof IntegrateTimothyRedaAction)
{
if(partName.equals("Timothy"))
{
((IntegrateTimothyRedaAction)action).addTimothy(a);
}
else if(partName.equals("Reda"))
{
((IntegrateTimothyRedaAction)action).addReda(a);
}
}
else if(action instanceof IntegratePegSigfreidoAction)
{
if(partName.equals("Peg"))
{
((IntegratePegSigfreidoAction)action).addPeg(a);
}
else if(partName.equals("Sigfreido"))
{
((IntegratePegSigfreidoAction)action).addSigfreido(a);
}
}
else if(action instanceof IntegrateAction)
{
if(partName.equals("Emp"))
{
((IntegrateAction)action).addEmp(a);
}
}
else if(action instanceof AcceptanceTestingAction)
{
if(partName.equals("Emp"))
{
((AcceptanceTestingAction)action).addEmp(a);
}
}
else if(action instanceof ReleaseCodeAndEndIterationAction)
{
if(partName.equals("Emp"))
{
((ReleaseCodeAndEndIterationAction)action).addEmp(a);
}
}
else if(action instanceof DeliverFinalProductToCustomerAction)
{
if(partName.equals("Emp"))
{
((DeliverFinalProductToCustomerAction)action).addEmp(a);
}
}
}
}
else if(objTypeName.equals("Manager"))
{
Manager a = state.getEmployeeStateRepository().getManagerStateRepository().get(keyValStr);
if(a != null)
{
if(action instanceof CreateUserStoriesAction)
{
}
else if(action instanceof ReleasePlanningMeetingAction)
{
if(partName.equals("Manager"))
{
((ReleasePlanningMeetingAction)action).addManager(a);
}
}
else if(action instanceof StartIterationAction)
{
}
else if(action instanceof IterationPlanningMeetingAction)
{
}
else if(action instanceof CreateAcceptanceTestsAction)
{
}
else if(action instanceof DesignAction)
{
}
else if(action instanceof CreateUnitTestsAction)
{
}
else if(action instanceof LearnCodingStandardAction)
{
}
else if(action instanceof ProgramAction)
{
}
else if(action instanceof PairProgramRobertJoyceAction)
{
}
else if(action instanceof PairProgramTimothyRedaAction)
{
}
else if(action instanceof PairProgramPegSigfreidoAction)
{
}
else if(action instanceof UnitTestingAndFixingAction)
{
}
else if(action instanceof RefactorAction)
{
}
else if(action instanceof IntegrateRobertJoyceAction)
{
}
else if(action instanceof IntegrateTimothyRedaAction)
{
}
else if(action instanceof IntegratePegSigfreidoAction)
{
}
else if(action instanceof IntegrateAction)
{
}
else if(action instanceof AcceptanceTestingAction)
{
}
else if(action instanceof ReleaseCodeAndEndIterationAction)
{
}
else if(action instanceof DeliverFinalProductToCustomerAction)
{
if(partName.equals("Emp"))
{
((DeliverFinalProductToCustomerAction)action).addEmp(a);
}
}
}
}
else if(objTypeName.equals("CustomerRep"))
{
CustomerRep a = state.getEmployeeStateRepository().getCustomerRepStateRepository().get(keyValStr);
if(a != null)
{
if(action instanceof CreateUserStoriesAction)
{
if(partName.equals("CustomerRep"))
{
((CreateUserStoriesAction)action).addCustomerRep(a);
}
}
else if(action instanceof ReleasePlanningMeetingAction)
{
if(partName.equals("CustomerRep"))
{
((ReleasePlanningMeetingAction)action).addCustomerRep(a);
}
}
else if(action instanceof StartIterationAction)
{
if(partName.equals("CustomerRep"))
{
((StartIterationAction)action).addCustomerRep(a);
}
}
else if(action instanceof IterationPlanningMeetingAction)
{
if(partName.equals("CustomerRep"))
{
((IterationPlanningMeetingAction)action).addCustomerRep(a);
}
}
else if(action instanceof CreateAcceptanceTestsAction)
{
if(partName.equals("CustRep"))
{
((CreateAcceptanceTestsAction)action).addCustRep(a);
}
}
else if(action instanceof DesignAction)
{
}
else if(action instanceof CreateUnitTestsAction)
{
}
else if(action instanceof LearnCodingStandardAction)
{
}
else if(action instanceof ProgramAction)
{
}
else if(action instanceof PairProgramRobertJoyceAction)
{
}
else if(action instanceof PairProgramTimothyRedaAction)
{
}
else if(action instanceof PairProgramPegSigfreidoAction)
{
}
else if(action instanceof UnitTestingAndFixingAction)
{
}
else if(action instanceof RefactorAction)
{
}
else if(action instanceof IntegrateRobertJoyceAction)
{
}
else if(action instanceof IntegrateTimothyRedaAction)
{
}
else if(action instanceof IntegratePegSigfreidoAction)
{
}
else if(action instanceof IntegrateAction)
{
}
else if(action instanceof AcceptanceTestingAction)
{
}
else if(action instanceof ReleaseCodeAndEndIterationAction)
{
}
else if(action instanceof DeliverFinalProductToCustomerAction)
{
if(partName.equals("Emp"))
{
((DeliverFinalProductToCustomerAction)action).addEmp(a);
}
}
}
}
}

private void setMinAndMax()
{
if(action instanceof CreateUserStoriesAction)
{
if(partName.equals("Developer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("CustomerRep"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("UserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof ReleasePlanningMeetingAction)
{
if(partName.equals("Developer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Manager"))
{
if(selectedEmp == null)
{
minNumParts = 0;
maxNumParts = 999999;}
else
{
minNumParts = 0;
maxNumParts = 999999;
}

}
else if(partName.equals("CustomerRep"))
{
if(selectedEmp == null)
{
minNumParts = 0;
maxNumParts = 999999;}
else
{
minNumParts = 0;
maxNumParts = 999999;
}

}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("UserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof StartIterationAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 6;
maxNumParts = 6;}
else
{
minNumParts = 6 - 1;
maxNumParts = 6 - 1;
}

}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("UserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("IterationPlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Design"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("UnitTests"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AcceptanceTests"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("CustomerRep"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
}
else if(action instanceof IterationPlanningMeetingAction)
{
if(partName.equals("Developer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("CustomerRep"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("IterationPlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof ChooseUserStoriesForIterationAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("IterationPlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof CreateProgrammingTasksAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("IterationPlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof CreateAcceptanceTestsAction)
{
if(partName.equals("Developer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("CustRep"))
{
if(selectedEmp == null)
{
minNumParts = 0;
maxNumParts = 999999;}
else
{
minNumParts = 0;
maxNumParts = 999999;
}

}
else if(partName.equals("Tests"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof DesignAction)
{
if(partName.equals("Developer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("CRCCards"))
{
minNumParts = 1;
maxNumParts = 999999;
}
else if(partName.equals("Design"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof CreateUnitTestsAction)
{
if(partName.equals("Developer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Tests"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("TestingFramework"))
{
minNumParts = 0;
maxNumParts = 999999;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedDesign"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof LearnCodingStandardAction)
{
if(partName.equals("Developer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("CodingStandard"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof ProgramAction)
{
if(partName.equals("Developer"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("CodingStandard"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedDesign"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUnitTests"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof PairProgramRobertJoyceAction)
{
if(partName.equals("Robert"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Joyce"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("CodingStandard"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedDesign"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUnitTests"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof PairProgramTimothyRedaAction)
{
if(partName.equals("Timothy"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Reda"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("CodingStandard"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedDesign"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUnitTests"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof PairProgramPegSigfreidoAction)
{
if(partName.equals("Peg"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Sigfreido"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("CodingStandard"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedDesign"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUnitTests"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof UnitTestingAndFixingAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("UnitTests"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("TestingTool"))
{
minNumParts = 0;
maxNumParts = 999999;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AcceptanceTests"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof RefactorAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("RefactoringTool"))
{
minNumParts = 0;
maxNumParts = 999999;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof IntegrateRobertJoyceAction)
{
if(partName.equals("Robert"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Joyce"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof IntegrateTimothyRedaAction)
{
if(partName.equals("Timothy"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Reda"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof IntegratePegSigfreidoAction)
{
if(partName.equals("Peg"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Sigfreido"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof IntegrateAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AssociatedUserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof AcceptanceTestingAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Cust"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AcceptanceTestCases"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("UserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof ReleaseCodeAndEndIterationAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AcceptanceTests"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("UserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof UpdateUserStoriesAttributesAction)
{
if(partName.equals("UserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Code"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof SetEmployeeProductivitiesAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof UpdateProjectAttributesAction)
{
if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
}
else if(action instanceof RequireReleasePlanDoOverAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("ReleasePlan"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("CustRep"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
}
else if(action instanceof CustomerComplainsAction)
{
if(partName.equals("CustRep"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof AllEmployeesIdleAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 6;
maxNumParts = 6;}
else
{
minNumParts = 6 - 1;
maxNumParts = 6 - 1;
}

}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof DeliverFinalProductToCustomerAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 1;}
else
{
minNumParts = 1 - 1;
maxNumParts = 1 - 1;
}

}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("UserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("AcceptanceTests"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof WarnOfImpendingDeadlineAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
else if(action instanceof GameOverAction)
{
if(partName.equals("Emp"))
{
if(selectedEmp == null)
{
minNumParts = 1;
maxNumParts = 999999;}
else
{
minNumParts = 1 - 1;
maxNumParts = 999999;
}

}
else if(partName.equals("Proj"))
{
minNumParts = 1;
maxNumParts = 1;
}
else if(partName.equals("UserStories"))
{
minNumParts = 1;
maxNumParts = 1;
}
}
}
public boolean actionCancelled()
{
return actionCancelled;
}

public class ExitListener extends WindowAdapter {
public void windowClosing(WindowEvent event) {
actionCancelled = true;
}
}
}
